{{- $release := .Release.Name}}
{{- $values := .Values}}
{{- $createToken := $values.createServiceAccountToken | toString | replace "<nil>" ""}}
{{- if $createToken | eq ""}}
{{- $createToken = semverCompare ">=1.24" $.Capabilities.KubeVersion.Version}}
{{- else}}
{{$createToken = $createToken | eq "true"}}
{{- end}}
{{- range $sa,$cfg := $values.accounts}}
{{- if $sa | contains "/" | not }}{{/* ignore external account references */}}
{{- $name := $values.useReleasePrefix | ternary (printf "%s-%s" $release $sa) ($sa)}}
---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: {{$name}}
{{- if $createToken}}
secrets:
- name: {{$name}}-token
{{- end}}
{{- with $cfg.pullSecrets}}
imagePullSecrets:
{{- range $x := .}}
- name: {{$x}}
{{- end}}
{{- end}}
{{- with $cfg.automountServiceAccountToken}}
automountServiceAccountToken: {{.}}
{{- end}}
---
{{- if $createToken}}
---
apiVersion: v1
kind: Secret
type: kubernetes.io/service-account-token
metadata:
  name: {{$name}}-token
  annotations:
    kubernetes.io/service-account.name: {{$name}}
{{- end}}
{{- end}}
{{- end}}


